SRM 400 Div1

这套题做的蛋疼菊紧

250

简单题。 问一个数能否被表示 成 某个素数的若干次方

我用了一个很损精度得法

其实只要判平方完了直接枚举素数就OK

vector<int>ans;
bool check(int x) {
    int m = (int)sqrt(x * 1.0) + 1;
    if(x == 2) return true;
    for(int i = 2; i <= m; i++) {
        if(x % i == 0) return false;
    }
    return true;
}
void gao(long long x) {
    int x1 = -1, x2 = -1;
    for(int i = 2; i < 60; i++) {
        int f = (int)(pow((double)x, 1.0 / i) + eps);
        long long tmp = 1;
        for(int j = 0; j < i; j++)
            tmp = tmp * (long long)f;
        if(tmp == x) {
            if(check(f)) {
                x1 = f, x2 = i;
            }
        }
    }
    if(x1 != -1) {
        ans.push_back(x1);
        ans.push_back(x2);
    }
}

500

区间DP

题目意思是说,给一个A串,一个B串

都是只包含0和1,然后用一些列reverse操作,将A变成B

reverse(i,j)表示把i,j这个区间反转

然后这系列操作有个限制

就是进行完一个操作之后,下一个操作必须在这个操作的区间中的子区间中进行,每个操作都是如此

然后这肯定是方便进行区间DP的

看有人写了一个很暴力的DFS, 没敢尝试,感觉复杂度没法算

dp[k][i][j][0]代表a串i位置开始长度为k的子串  不翻转 变成b串j位置开始长度为k的子串 需要的步数

dp[k][i][j][1]代表a串i位置开始长度为k的子串  翻转 变成b串j位置开始长度为k的子串 需要的步数

 int n = a.size();
        memset(dp, 0x3f, sizeof(dp));
        for(int j = 0; j <= n; j++)
            for(int k = 0; k <= n; k++)
                dp[0][j][k][0] = dp[0][j][k][1] = 0;
        for(int i = 1; i <= n; i++)
            for(int j = 0; j + i <= n; j++)
                for(int k = 0; k + i <= n; k++) {
                    if(a[j] == b[k]) {
                        dp[i][j][k][0] = min(dp[i][j][k][0], dp[i - 1][j + 1][k + 1][0]);
                    }
                    if(a[j + i - 1] == b[k + i - 1]) {
                        dp[i][j][k][0] = min(dp[i][j][k][0], dp[i - 1][j][k][0]);
                    }
                    if(a[j] == b[k + i - 1]) {
                        dp[i][j][k][1] = min(dp[i][j][k][1], dp[i - 1][j + 1][k][1]);
                    }
                    if(a[j + i - 1] == b[k]) {
                        dp[i][j][k][1] = min(dp[i][j][k][1], dp[i - 1][j][k + 1][1]);
                    }
                    dp[i][j][k][0] = min(dp[i][j][k][0], dp[i][j][k][1] + 1);
                    dp[i][j][k][1] = min(dp[i][j][k][1], dp[i][j][k][0] + 1);
            }
        return dp[n][0][0][0] >= 1000 ? -1: dp[n][0][0][0];

1000

这题公式很简单

n*(1/n+1/(n - 1) + 1/ (n - 2) +...+ 1/(n - k + 1) )

关键问题来了

n ,k都巨大

然后发现这个是个调和级数求和

数字大的时候只有近似公式

那么试试呗

(1/n+1/(n - 1) + 1/ (n - 2) +...+ 1/(n - k + 1) ) 约等于  log(n + 1) + R

R是欧拉常数

完了k大的时候就用这个公式去搞。不然直接for了

但是wa出翔了

最后发现别人这么干的   本来求出来的公式是log((n + 1) / (n - k + 1))

然后有个函数叫log1p ,是干什么的呢  log1p(x)返回的就是log(x + 1)

但是问题来了,当x巨小的时候,log1p的精度比较高,用log的时候x+1就丢精度了

然后就凑呗,凑着用log1p还不行,分母减个0.5,就是用来调控精度的。

这给我蛋疼的。

完了发现房里好多不用log1p的, 我全给cha掉了

 double expectedBuy(string n, string k)
    {
        long long x = gao(n);
        long long y = gao(k);
        double ans = 0;
        long long s = x - y + 1;
        long long mx = 10000000;
        while(s <= mx) {
            ans += 1.0 / s;
            if(s == x) return x * ans;
            s++;
        }
        ans += log1p((double)(x - s + 1) / (s - 0.5));

        return ans * x;
    }
时间: 2024-10-11 05:52:04

SRM 400 Div1的相关文章

topcoder srm 400 div1

problem1 link 枚举指数,然后判断是不是素数即可. problem2 link 令$f[len][a][b][r]$(r=0或者1)表示子串$init[a,a+len-1]$匹配$goal[b,b+len-1]$,翻转了$r$次的最小代价. problem3 link 答案的公式很容易推导,为$n*\sum_{i=n-k+1}^{n}\frac{1}{i}$. 调和级数为$H(n)=\sum_{i=1}^{n}\frac{1}{i}$ 所以答案为$n*(H(n)-H(n-k))$ 由

Topcoder SRM 643 Div1 250&lt;peter_pan&gt;

Topcoder SRM 643 Div1 250 Problem 给一个整数N,再给一个vector<long long>v; N可以表示成若干个素数的乘积,N=p0*p1*p2*......*pn,我们假设p0,p1,...,pn是单调不降的,那么v里存储的是下标为偶数 的N的质因数p0,p2,p4,...,p(2k).现在要求写一个程序,返回一个vector<long long>ans; ans里存储的是p0,p1,p2,...,pn. Limits Time Limit(m

SRM 618 DIV1 500

非常棒的组合问题,看了好一会,无想法.... 有很多做法,我发现不考虑顺序的最好理解,也最好写. 结果一定是两种形式 A....A   dp[n-1] A...A...A sgma(dp[j]*dp[n-j-1])( 1<=j<=n-2) 最后乘上n! 什么时候才能自己在比赛中做出一个500分来啊!!! class LongWordsDiv1 { public : int count(int n) { int i,j; fact[0] = 1; for(i = 1; i <= n; i

SRM 631 DIV1

SRM 631 DIV1 A:最多肯定只需要两步,中间的两行,一行黑,一行白就可以了,这样的话,只需要考虑一开始就满足,和枚举一行去染色满足的情况就可以了,暴力即可 B:贪心,一个记录当前有猫的位置和当前超过一只猫的位置,然后位置排序从左往右找,如果当前能移动到之前超过两只的位置,就全部移动过去,不增加,如果不行,那么考虑当前这个能不能铺成一条,如果可以,相应更新位置,如果不行,就让猫全部堆到右边右边去,然后堆数多1 代码: A: #include <iostream> #include &l

SRM 622 div1 250

Problem Statement    In the Republic of Nlogonia there are N cities. For convenience, the cities are numbered 0 through N-1. For each two different cities i and j, there is a direct one-way road from i to j. You are given the lengths of those roads a

SRM 587 DIV1

550 结论:同一层的交点共线. 很容易猜到,也可以跑几组数据验证. 利用结论就可以按层算,再利用对称性简化计算. 1 using namespace std; 2 #define maxn 70100 3 class TriangleXor { 4 public: 5 int theArea(int); 6 }; 7 double l[maxn] , x[maxn] , y[maxn] , H; 8 int idx; 9 10 void addpoint(double k,double w)

Topcoder SRM 648 Div1 250

Problem 给一个长度为N的"AB"字符串S,S只含有两种字符'A' 或 'B',设pair(i,j)(0=<i<j<N)表示一对 i,j 使得S[i]='A',S[j]='B'.现给定一个K,求字符串S,使得pair(i,j)的个数恰好为K.若不存在,则返回空串. Limits Time Limit(ms): 2000 Memory Limit(MB): 256 N: [2, 50] K: [0 , N*(N-1)/2 ] Solution 若K>(N/2

Topcoder SRM 627 div1 HappyLettersDiv1 : 字符串

Problem Statement      The Happy Letter game is played as follows: At the beginning, several players enter the field. Each player has a lowercase English letter on their back. The game is played in turns. In each turn, you select two players with dif

[TC SRM 697 div1 lev1] DivisibleSetDiv1

Tutorial:https://apps.topcoder.com/wiki/display/tc/SRM+697#DivisibleSetDiv1 Note:证明过程值得一看. 主要内容:寻找[x1,x2,...,xn]使得满足bi * xi >= S - xi,其中S = x1 + x2 + ... + xn.